---
title: Introduction to WebRTC protocols
slug: Web/API/WebRTC_API/Protocols
tags:
  - API
  - Audio
  - Beginner
  - Draft
  - Guide
  - ICE
  - Media
  - NAT
  - SDP
  - STUN
  - TURN
  - Video
  - WebRTC
  - WebRTC API
---
<div>{{WebRTCSidebar}}{{draft}}</div>

<p>This article introduces the protocols on top of which the WebRTC API is built.</p>

<h2 id="ICE">ICE</h2>

<p><a href="http://en.wikipedia.org/wiki/Interactive_Connectivity_Establishment">Interactive Connectivity Establishment (ICE)</a> is a framework to allow your web browser to connect with peers. There are many reasons why a straight up connection from Peer A to Peer B won’t work. It needs to bypass firewalls that would prevent opening connections, give you a unique address if like most situations your device doesn’t have a public IP address, and relay data through a server if your router doesn’t allow you to directly connect with peers. ICE uses STUN and/or TURN servers to accomplish this, as described below.</p>

<h2 id="STUN">STUN</h2>

<p><a href="http://en.wikipedia.org/wiki/STUN">Session Traversal Utilities for <u>NAT</u> (STU<u>N</u>)</a> (acronym within an acronym) is a protocol to discover your public address and determine any restrictions in your router that would prevent a direct connection with a peer.</p>

<p>The client will send a request to a STUN server on the Internet who will reply with the client’s public address and whether or not the client is accessible behind the router’s NAT.</p>

<p><img alt="An interaction between two users of a WebRTC application involving a STUN server." src="https://mdn.mozillademos.org/files/6115/webrtc-stun.png" style="display: block; height: 378px; margin: 0px auto; width: 259px;"></p>

<h2 id="NAT">NAT</h2>

<p><a href="https://en.wikipedia.org/wiki/Network_address_translation">Network Address Translation (NAT)</a> is used to give your device a public IP address. A router will have a public IP address and every device connected to the router will have a private IP address. Requests will be translated from the device’s private IP to the router’s public IP with a unique port. That way you don’t need a unique public IP for each device but can still be discovered on the Internet.</p>

<p>Some routers will have restrictions on who can connect to devices on the network. This can mean that even though we have the public IP address found by the STUN server, not anyone can create a connection. In this situation we need to turn to TURN.</p>

<h2 id="TURN">TURN</h2>

<p>Some routers using NAT employ a restriction called ‘Symmetric NAT’. This means the router will only accept connections from peers you’ve previously connected to.</p>

<p><a href="http://en.wikipedia.org/wiki/TURN">Traversal Using Relays around NAT (TURN)</a> is meant to bypass the Symmetric NAT restriction by opening a connection with a TURN server and relaying all information through that server. You would create a connection with a TURN server and tell all peers to send packets to the server which will then be forwarded to you. This obviously comes with some overhead so it is only used if there are no other alternatives.</p>

<p><img alt="An interaction between two users of a WebRTC application involving STUN and TURN servers." src="https://mdn.mozillademos.org/files/6117/webrtc-turn.png" style="display: block; height: 297px; margin: 0px auto; width: 295px;"></p>

<h2 id="SDP">SDP</h2>

<p><a href="http://en.wikipedia.org/wiki/Session_Description_Protocol">Session Description Protocol (SDP)</a> is a standard for describing the multimedia content of the connection such as resolution, formats, codecs, encryption, etc. so that both peers can understand each other once the data is transferring. This is, in essence, the metadata describing the content and not the media content itself.</p>

<p>Technically, then, SDP is not truly a protocol, but a data format used to describe connection that shares media between devices.</p>

<p>Documenting SDP is well outside the scope of this documentation; however, there are a few things worth noting here.</p>

<h3 id="Structure">Structure</h3>

<p>SDP consists of one or more lines of UTF-8 text, each beginning with a one-character type, followed by an equals sign (<code>"="</code>), followed by structured text comprising a value or description, whose format depends on the type. The lines of text that begin with a given letter are generally referred to as "<em>letter</em>-lines". For example, lines providing media descriptions have the type <code>"m"</code>, so those lines are referred to as "m-lines."</p>

<h3 id="For_more_information">For more information</h3>

<p>To learn more about SDP, see the following useful resources:</p>

<ul>
 <li>Specification: {{RFC(4566, "SDP: Session Description Protocol")}}</li>
 <li><a href="https://www.iana.org/assignments/sip-parameters/sip-parameters.xhtml">IANA registry of SDP parameters</a></li>
</ul>
